﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

function initDCoordsMapFrame()
    log("initDCoordsMapFrame()");

    Coordinates_worldMapText = WorldMapButton:CreateFontString()
    Coordinates_worldMapText:SetTextColor(DCoords_MapFontR,DCoords_MapFontG,DCoords_MapFontB,DCoords_MapFontA);
    Coordinates_worldMapText:SetPoint("BOTTOM", WorldMapButton, "BOTTOM", 0, 6)

    --[[
    local fontSize = 20
    local fontStyle = "Fonts\\bLEI00D.TTF"
    local fontOutline = "OUTLINE"

    scaledFontSize = fontSize / WorldMapDetailFrame:GetEffectiveScale();
    Coordinates_worldMapText:SetFont(fontStyle, scaledFontSize, fontOutline);
    Coordinates_worldMapText:SetText("DCoords v"..DCoordsVersion);
    --]]
    
    WorldMapButton:SetScript("OnEnter",function(self,v)
        --setMouseMapState(true);
    end);
    WorldMapButton:SetScript("OnLeave",function(self,v)
        --setMouseMapState(false);
    end);
    
    WorldMapFrame:HookScript("OnEnter", function()
        setMouseMapState(true);
    end);
    
    WorldMapFrame:HookScript("OnLeave", function()
        setMouseMapState(false);
    end);
    
    
    
end


function setMouseMapState(state)
    mouseIsOverMap = state;
end



function setDCoordsMapFrameText(arg)
    Coordinates_worldMapText:SetText(arg);
    Coordinates_worldMapText:SetTextColor(DCoords_MapFontR,DCoords_MapFontG,DCoords_MapFontB,DCoords_MapFontA);
    Coordinates_worldMapText:SetFont(getMapFrameFont(), DCoords_MapFrameFontSize,"OUTLINE");
end



function updateDCoordsMapFrameState()
    log("updateDCoordsMapFrameState()");

    if (DCoords_MapFrameVisible == true) then
        Coordinates_worldMapText:Show();
    else
        Coordinates_worldMapText:Hide();
    end
    
    Coordinates_worldMapText:SetTextColor(DCoords_MapFontR,DCoords_MapFontG,DCoords_MapFontB,DCoords_MapFontA);
    Coordinates_worldMapText:SetFont(getMapFrameFont(), DCoords_MapFrameFontSize,"OUTLINE");
        
end



