﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function log(arg)
    if (DCoordsDebug) then
        print(tostring(arg))
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function toChat(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getSystemDefaultFont()
    return ("Fonts\\FRIZQT.TTF");
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getAddonDefaultFont()
	local font = lsm:Fetch("font","Font "..1,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMainFrameFont()
    --local f = 16;
	--log("Trying to find Font " .. DCoords_MainFrameFont);
	local font = lsm:Fetch("font","Font "..DCoords_MainFrameFont,true);
    --log(fontFiles[f]);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMainFrameFontName()
    return "Font " .. tostring(DCoords_MainFrameFont);
	--return fontNames[DCoords_MainFrameFont]
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getFontAtIndex(index)
	local font = lsm:Fetch("font","Font "..index,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMapFrameFont()
	local font = lsm:Fetch("font","Font "..DCoords_MapFrameFont,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMapFrameFontName()
	return fontFiles[DCoords_MapFrameFont]
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function invertBoolean(bool)
    if (bool == true) then
        return false;
    else
        return true;
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createText(frame,label,size,x,y)
    local cfs = frame:CreateFontString(nil, 'ARTWORK');
    cfs:SetPoint("TOPLEFT", x, y);
    cfs:SetFont(getAddonDefaultFont(), size,"OUTLINE");
    cfs:SetShadowOffset(1, -1);
    cfs:SetTextColor(1, 1, 1);
    cfs:SetNonSpaceWrap(false);
    cfs:SetText(label);
    return cfs;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createCheckbox(frame,id,label,size,x,y,callBackFunction)
	local checkbox = CreateFrame("CheckButton", id, frame);
	checkbox:SetWidth(20);
	checkbox:SetHeight(23);
	checkbox:SetPoint("TOPLEFT", x, y);
	
	checkbox:SetHitRectInsets(0, -200, 0, 0);
	checkbox:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
	checkbox:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
	checkbox:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight");
	checkbox:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
	
	local description = checkbox:CreateFontString(id.."Label", "ARTWORK", "GameFontHighlight");
	description:SetPoint("LEFT", checkbox, "RIGHT", 1, 1);
	description:SetText(label);
	description:SetTextColor(1,1,1);
	description:SetFont(getAddonDefaultFont(), size,"OUTLINE");
    local txtW = description:GetStringWidth();
    checkbox:SetHitRectInsets(0, -txtW, 0, 0);
	
	
	checkbox:SetScript("OnClick", function(frame)
		local tick = frame:GetChecked();
		if tick then
			playClick();
            _G[callBackFunction](true);
		else
			playClick();
            _G[callBackFunction](false);
		end
	end)	
	
	return checkbox;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createSlider(frame,id,x,y,min,max,default,label,width,callBackFunction)

    

	local MySlider = CreateFrame("Slider", id, frame, "OptionsSliderTemplate");
	MySlider:ClearAllPoints();
	MySlider:SetPoint("TOPLEFT", x, y);
	MySlider:SetMinMaxValues(min,max);
	MySlider:SetValue(default);
    MySlider:SetOrientation('HORIZONTAL')
    MySlider:SetWidth(width);
    MySlider:SetHeight(18);
    MySlider:SetObeyStepOnDrag(true);
    
	getglobal(MySlider:GetName() .. 'Low'):SetText(min);
	getglobal(MySlider:GetName() .. 'High'):SetText(max);
    
    if (label ~= "") then
	    getglobal(MySlider:GetName() .. 'Text'):SetText(label .. " . " .. string.format("%.2f",default));
    else   
        getglobal(MySlider:GetName() .. 'Text'):SetText(string.format("%.2f",default));
    end
    
    getglobal(MySlider:GetName() .. 'Low'):SetFont(getAddonDefaultFont(),10,"OUTLINE")
    getglobal(MySlider:GetName() .. 'High'):SetFont(getAddonDefaultFont(),10,"OUTLINE")
    getglobal(MySlider:GetName() .. 'Text'):SetFont(getAddonDefaultFont(),10,"OUTLINE")
    
	MySlider:Show();
	MySlider:SetScript("OnValueChanged", function(self, value)
        if (label ~= "") then
            getglobal(MySlider:GetName() .. 'Text'):SetText(label .. " . " .. string.format("%.2f",value));
        else   
            getglobal(MySlider:GetName() .. 'Text'):SetText(string.format("%.2f",value));
        end
        _G[callBackFunction](value);
	end)
    	
	return MySlider;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #